﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.Objects;
using System.Data.EntityClient;
using System.Data.Common;

namespace TestModelFirst
{
   public partial class Form1 : Form
   {
      public Form1()
      {
         InitializeComponent();
      }

      private void btnAdd_Click(object sender, EventArgs e)
      {
         // Create a new purchase.
         Purchases NewPurchase = new Purchases();
         NewPurchase.Amount = new Decimal(5.99);
         NewPurchase.PurchaseDate = DateTime.Now;

         // Create a new customer and add the purchase.
         Customers NewCustomer = new Customers();
         NewCustomer.CustomerName = "Josh Bailey";

         // Create the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Add the record and save it.
         context.Customers.Add(NewCustomer);
         context.Purchases.Add(NewPurchase);
         context.SaveChanges();

         // Display a success message.
         MessageBox.Show("Record Added");
      }

      private void btnQuery_Click(object sender, EventArgs e)
      {
          // Create the context.
          EntityConnection conn = 
              new EntityConnection("name=Rewards2ModelContainer");
          ObjectContext context = new ObjectContext(conn);

          // Define a command string for making the query.
          String EntitySQLCmd = 
              "SELECT VALUE CustomerList " +
              "FROM Rewards2ModelContainer.Customers " +
              "AS CustomerList";

          // Create a query object.
          ObjectQuery<Customers> Query = 
              new ObjectQuery<Customers>(EntitySQLCmd, context);

          // Execute the query.
          List<Customers> Result = Query.Execute(MergeOption.NoTracking).ToList();

          // Display the customer name on screen.
          MessageBox.Show(Result[0].CustomerName);
      }

      private void btnQuery2_Click(object sender, EventArgs e)
      {
          // Create the context.
          EntityConnection conn = 
              new EntityConnection("name=Rewards2ModelContainer");
          ObjectContext context = new ObjectContext(conn);

          // Define a command string for making the query.
          String EntitySQLCmd =
              "SELECT CustomerList.Id, CustomerList.CustomerName " +
              "FROM Rewards2ModelContainer.Customers " +
              "AS CustomerList";

          // Create a query object.
          ObjectQuery<DbDataRecord> Customers = 
              context.CreateQuery<DbDataRecord>(EntitySQLCmd);

          // Display the customer name on screen.
          MessageBox.Show(Customers.First()["CustomerName"].ToString());
      }

      private void btnNewPurchases_Click(object sender, EventArgs e)
      {
          // Create the query context.
          EntityConnection conn =
              new EntityConnection("name=Rewards2ModelContainer");
          ObjectContext context = new ObjectContext(conn);

          // Define a command string for making the query.
          String EntitySQLCmd =
              "SELECT CustomerList.Id, CustomerList.CustomerName " +
              "FROM Rewards2ModelContainer.Customers " +
              "AS CustomerList";

          // Create a query object.
          List<DbDataRecord> Customers =
              context.CreateQuery<DbDataRecord>(EntitySQLCmd).ToList();

         // Create the management context.
         Rewards2ModelContainer management = new Rewards2ModelContainer();

          // Create new purchases for Josh Bailey.
          Purchases NewPurchase1 = new Purchases();
          NewPurchase1.CustomersId = Convert.ToInt32(Customers[0][0]);
          NewPurchase1.Amount = new Decimal(10.99);
          NewPurchase1.PurchaseDate = new DateTime(2013, 3, 20);
          management.Purchases.Add(NewPurchase1);

          Purchases NewPurchase2 = new Purchases();
          NewPurchase2.CustomersId = Convert.ToInt32(Customers[0][0]);
          NewPurchase2.Amount = new Decimal(3.99);
          NewPurchase2.PurchaseDate = new DateTime(2013, 3, 14);
          management.Purchases.Add(NewPurchase2);

          // Create new purchases for Christian Hess.
          Purchases NewPurchase3 = new Purchases();
          NewPurchase3.CustomersId = Convert.ToInt32(Customers[1][0]);
          NewPurchase3.Amount = new Decimal(0.99);
          NewPurchase3.PurchaseDate = new DateTime(2013, 3, 18);
          management.Purchases.Add(NewPurchase3);

          Purchases NewPurchase4 = new Purchases();
          NewPurchase4.CustomersId = Convert.ToInt32(Customers[1][0]);
          NewPurchase4.Amount = new Decimal(15.99);
          NewPurchase4.PurchaseDate = new DateTime(2013, 3, 19);
          management.Purchases.Add(NewPurchase4);

          // Save the purchases to the database.
          Int32 NumRecords = management.SaveChanges();

          // Display a success message.
          MessageBox.Show(NumRecords.ToString() + " New Records Added!");
      }

      private void btnQuery3_Click(object sender, EventArgs e)
      {
          // Create the context.
          EntityConnection conn =
              new EntityConnection("name=Rewards2ModelContainer");
          ObjectContext context = new ObjectContext(conn);

          // Define a command string for making the query.
          String EntitySQLCmd =
              "SELECT CustomerList.Id, CustomerList.CustomerName " +
              "FROM Rewards2ModelContainer.Customers " +
              "AS CustomerList " +
              "WHERE CustomerList.CustomerName='Josh Bailey'";

          // Create a query object.
          ObjectQuery<DbDataRecord> Customers =
              context.CreateQuery<DbDataRecord>(EntitySQLCmd);

          // Create an output string.
          StringBuilder Output = 
              new StringBuilder("Customer Data:");
          DbDataRecord ThisRecord = Customers.First();
          for (int i = 0; i < ThisRecord.FieldCount; i++)
              Output.Append("\r\n\t" + ThisRecord.GetName(i) + 
                  ": " + ThisRecord[i].ToString());

          // Display the customer name on screen.
          MessageBox.Show(Output.ToString());
      }

      private void btnQuery4_Click(object sender, EventArgs e)
      {
          // Create the context.
          EntityConnection conn =
              new EntityConnection("name=Rewards2ModelContainer");
          ObjectContext context = new ObjectContext(conn);

          // Define a command string for making the query.
          String EntitySQLCmd =
              "SELECT PurchaseList, PurchaseList.Customer.CustomerName " +
              "FROM Rewards2ModelContainer.Purchases " +
              "AS PurchaseList " +
              "WHERE PurchaseList.PurchaseDate > DATETIME '2013-02-17 00:00'";

          // Create a query object.
          ObjectQuery<DbDataRecord> Purchases =
              context.CreateQuery<DbDataRecord>(EntitySQLCmd);

          // Create an output string.
          StringBuilder Output =
              new StringBuilder("Purchase Data:");

          // Process the individual purchase records.
          foreach (var Purchase in Purchases)
          {
              // Add the customer name.
              Output.Append("\r\n\t" + Purchase[1]);

              // Obtain access to the purchase information.
              var PurchaseInfo = Purchase[0] as Purchases;

              // Add the purchase information.
              Output.Append(" spent " + PurchaseInfo.Amount +
                  " on " + PurchaseInfo.PurchaseDate + ".");
          }

          // Display the customer name on screen.
          MessageBox.Show(Output.ToString());
      }

      private void btnQuery5_Click(object sender, EventArgs e)
      {
          // Create the context.
          EntityConnection conn =
              new EntityConnection("name=Rewards2ModelContainer");
          ObjectContext context = new ObjectContext(conn);

          // Define a command string for making the query.
          String EntitySQLCmd =
              "SELECT PurchaseList, PurchaseList.Customer.CustomerName " +
              "FROM Rewards2ModelContainer.Purchases " +
              "AS PurchaseList " +
              "WHERE PurchaseList.Amount > 1.00M " +
                     "&& PurchaseList.Amount < 10.00M";

          // Create a query object.
          ObjectQuery<DbDataRecord> Purchases =
              context.CreateQuery<DbDataRecord>(EntitySQLCmd);

          // Create an output string.
          StringBuilder Output =
              new StringBuilder("Purchase Data:");

          // Process the individual purchase records.
          foreach (var Purchase in Purchases)
          {
              // Add the customer name.
              Output.Append("\r\n\t" + Purchase[1]);

              // Obtain access to the purchase information.
              var PurchaseInfo = Purchase[0] as Purchases;

              // Add the purchase information.
              Output.Append(" spent " + PurchaseInfo.Amount +
                  " on " + PurchaseInfo.PurchaseDate + ".");
          }

          // Display the customer name on screen.
          MessageBox.Show(Output.ToString());
      }

      private void btnQuery6_Click(object sender, EventArgs e)
      {
          // Create the context.
          EntityConnection conn =
              new EntityConnection("name=Rewards2ModelContainer");
          ObjectContext context = new ObjectContext(conn);

          // Define a command string for making the query.
          String EntitySQLCmd =
              "SELECT PurchaseList, PurchaseList.Customer.CustomerName " +
              "FROM Rewards2ModelContainer.Purchases " +
              "AS PurchaseList " +
              "WHERE PurchaseList.PurchaseDate > DATETIME '2013-02-17 00:00' " +
              "ORDER BY PurchaseList.CustomersId, " +
              "PurchaseList.PurchaseDate";

          // Create a query object.
          ObjectQuery<DbDataRecord> Purchases =
              context.CreateQuery<DbDataRecord>(EntitySQLCmd);

          // Create an output string.
          StringBuilder Output =
              new StringBuilder("Purchase Data:");

          // Process the individual purchase records.
          foreach (var Purchase in Purchases)
          {
              // Add the customer name.
              Output.Append("\r\n\t" + Purchase[1]);

              // Obtain access to the purchase information.
              var PurchaseInfo = Purchase[0] as Purchases;

              // Add the purchase information.
              Output.Append(" spent " + PurchaseInfo.Amount +
                  " on " + PurchaseInfo.PurchaseDate + ".");
          }

          // Display the customer name on screen.
          MessageBox.Show(Output.ToString());
      }

      private void btnQuery7_Click(object sender, EventArgs e)
      {
          // Create the context.
          EntityConnection conn =
              new EntityConnection("name=Rewards2ModelContainer");
          ObjectContext context = new ObjectContext(conn);

          // Define a command string for making the query.
          String EntitySQLCmd =
              "SELECT Grouping.CustomersId, " +
              "  (SELECT PurchaseList, PurchaseList.Customer.CustomerName " +
              "   FROM Rewards2ModelContainer.Purchases " +
              "   AS PurchaseList " +
              "   WHERE PurchaseList.CustomersId = Grouping.CustomersId " +
              "   ORDER BY PurchaseList.Amount) " +
              "FROM Rewards2ModelContainer.Purchases " +
              "AS Grouping " +
              "GROUP BY Grouping.CustomersId";

          // Create a query object.
          ObjectQuery<DbDataRecord> CustomerData =
              context.CreateQuery<DbDataRecord>(EntitySQLCmd);

          // Discover the query being sent to the server.
          String QueryString = CustomerData.ToTraceString();

          // Turn off change tracking.
          CustomerData.MergeOption = MergeOption.NoTracking;

          // Create an output string.
          StringBuilder Output =
              new StringBuilder("Purchase Data:");

          // Process the data records.
          foreach (var Customer in CustomerData)
          {
              // Obtain the list of customer data as a List.
              var CustomerList = (List<DbDataRecord>)Customer[1];

              // Add the customer's name.
              Output.Append("\r\n\t" + CustomerList.First()[1]);

              // Process each purchase in the list.
              foreach (var Purchase in CustomerList)
              {
                  // Add the purchase data.
                  var PurchaseData = (Purchases)Purchase[0];
                  Output.Append("\r\n\t\t" + PurchaseData.Amount);
                  Output.Append(" on " + PurchaseData.PurchaseDate);
              }
          }

          // Display the customer name on screen.
          MessageBox.Show(Output.ToString());
      }
   }
}
